/*
 * ASE1805.asm
 *
 *  Created: 29/06/2018 8.51.10
 *   Author: Roberto Roncella
 *
 * Realizzare un sottoprogramma per il microcontrollore AVR XMEGA256A3BU, 
 * in grado di moltiplicare il numero con segno (C2) da 8 bit, contenuto all'indirizzo puntato da X,
 * con il numero con segno (C2) da 16 bit, contenuto all'indirizzo puntato da Y.
 * Il risultato (valutare quanti byte sono necessari per la sua rappresentazione senza errori in C2)
 * deve essere posto in memoria all'indirizzo puntato da Z. 
 * Per i valori numerici multibyte, le parti pi significative hanno (come d'uso) indirizzi maggiori.
 */ 

main:
 ldi XL,low(0x2000)
 ldi XH,high(0x2000)
 ldi YL,low(0x2100)
 ldi YH,high(0x2100)
 ldi ZL,low(0x2200)
 ldi ZH,high(0x2200)
 rcall mulsX_YW //solo per debug
 rjmp main

/* Il risultato richiede 3 byte. Infatti il range del risultato e` [-2^15*(2^7-1);2^22] 
 * e richiede 24 bit, il cui range di rappresentabilita` e` [-2^23;2^23-1]
 */ 
 
mulsX_YW:
 push R0
 push R1
 push R16
 push R18
 push R19
 push R20
 push R21
 ld R16,X //in R16 il fattore (X)
 ld R18,Y //in R18 (Y)_L
 ldd R19,Y+1 //in R19 (Y)_H
 mulsu R16,R18 //la parte bassa e` senza segno
 st Z,R0 //salvo il primo byte del risultato
 mov R20,R1 //appoggia il byte centrale del risultato (parziale)
 sbc R21,R21 //il risultato e` 0xFF se c'e` stato carry 0 altrimenti (segno esteso)
 muls R16,R19 //entrambi con segno
 add R20,R0
 adc R21,R1
 std Z+1,R20
 std Z+2,R21
 pop R21
 pop R20
 pop R19
 pop R18 
 pop R16
 pop R1
 pop R0 
 ret